//
//  CDVGCTouchID.h
//  CDVGCTouchID
//
//  MIT License
//
//  Copyright (c) 2017 Giulio Caruso aka rdn. All rights reserved.
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in all
//  copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//  SOFTWARE.

#import <Cordova/CDV.h>

@interface CDVGCTouchID : CDVPlugin

#pragma mark Methods for CDVGCTouchID
    
/**
*  Check Device Available for TouchID
*
*  @param command
*/
-(void)isAvailable:(CDVInvokedUrlCommand *)command;

/**
*  Try Auth with Touch ID
*
*  @param command with this param you can pass many info for Touch ID
*
*/
-(void)authWithTouchID:(CDVInvokedUrlCommand *)command;


-(void)setPassword:(CDVInvokedUrlCommand *)command;

#pragma mark Utility for Auth with Password

/**
* Check if u want keyChain or NSUsersDefaults
*
* @param pwd true 'USE KeyChain' false 'USE NSUsersDefaults'
*/
-(BOOL)isValidPassword:(NSString *)pwd;

/**
 * Return true in successCallback
 *
 * @param command : This param have many info for this function
 */
-(void)returnSuccess:(CDVInvokedUrlCommand *)command;

/**
 * Return false in errorCallback
 *
 * @param command : This param have many info for this function
 */
-(void)returnError:(CDVInvokedUrlCommand *)command;
@end
